///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// This design is confidential and proprietary of Xilinx, All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  /   Vendor			: Xilinx
// \   \   \/    Version		: $Name: mig_v1_7_b7 $
//  \   \        Application		: MIG
//  /   /        Filename		: vlog_xst_bl4_cal_top.v
// /___/   /\    Date Last Modified	: $Date: 2007/02/10 07:05:49 $
// \   \  /  \   Date Created		: Mon May 2 2005
//  \___\/\___\
// Device	: Spartan-3/3A
// Design Name	: DDR2 SDRAM
// Purpose	: This module has the instantiations cal_ctl and tap_dly.
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps
module vlog_xst_bl4_cal_top
  (
   input        clk0,
   input        clk0dcmlock,
   input        reset,
   output [4:0] tapForDqs
   );

   wire [31:0]  flop2_val;
   wire         fpga_rst;

   assign       fpga_rst = ~reset || ~clk0dcmlock;

   vlog_xst_bl4_cal_ctl cal_ctl0 
     (
      .clk       (clk0), 
      .reset     (fpga_rst), 
      .flop2     (flop2_val), 
      .tapForDqs (tapForDqs)
      );
   vlog_xst_bl4_tap_dly tap_dly0 
     (
      .clk(clk0), 
      .reset(fpga_rst), 
      .tapIn(clk0), 
      .flop2(flop2_val)
      );

endmodule
