///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// This design is confidential and proprietary of Xilinx, All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  /   Vendor			: Xilinx
// \   \   \/    Version		: $Name: mig_v1_7_b7 $
//  \   \        Application		: MIG
//  /   /        Filename		: vlog_xst_bl4_clk_dcm.v
// /___/   /\    Date Last Modified	: $Date: 2007/02/10 07:05:49 $
// \   \  /  \   Date Created		: Mon May 2 2005
//  \___\/\___\
// Device	: Spartan-3/3A
// Design Name	: DDR2 SDRAM
// Purpose	: This module has the DCM instantiation to DDR2 SDRAM controller.
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps
module vlog_xst_bl4_clk_dcm
  (
   input  input_clk,
   input  rst,
   output clk,
   output clk90,
   output ckdiv_out,
   output dcm_lock
   );

   parameter GND = 1'b0;

   wire       clk90dcm;
   wire       divdcm;
   wire       clk0_buf;
   wire       clk90_buf;
   wire       dcm1_lock;
   wire [7:0] status;

   defparam   DCM_INST1.DLL_FREQUENCY_MODE = "LOW";
   defparam   DCM_INST1.DUTY_CYCLE_CORRECTION = "TRUE";
   defparam   DCM_INST1.CLKDV_DIVIDE = 4.0;

   assign     clk   = clk0_buf;
   assign     clk90 = clk90_buf;

   DCM DCM_INST1
     (
              .CLKIN    (input_clk),
              .CLKFB    (clk0_buf),
              .DSSEN    (GND),
              .PSINCDEC (GND),
              .PSEN     (GND),
              .PSCLK    (GND),
              .RST      (rst),
              .CLK0     (clk0dcm),
              .CLK90    (clk90dcm),
              .CLK180   (),
              .CLK270   (),
              .CLK2X    (),
              .CLK2X180 (),
              .CLKDV    (divdcm),
              .CLKFX    (),
              .CLKFX180 (),
              .LOCKED   (dcm1_lock),
              .PSDONE   (),
              .STATUS   (status)
              );

   BUFG BUFG_CLK0
     (
      .O(clk0_buf),
      .I(clk0dcm)
      );

   BUFG BUFG_CLK90
     (
      .O(clk90_buf),
      .I(clk90dcm)
      );

   BUFG BUFG_CLKDIV
     (
      .O(ckdiv_out),
      .I(divdcm)
      );
   
   assign     dcm_lock = dcm1_lock;
   
endmodule
