///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// This	design is confidential and proprietary of Xilinx, All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /	/\/   /
// /___/  \  /   Vendor			: Xilinx
// \   \   \/    Version		: $Name: mig_v1_7_b7 $
//  \	\        Application		: MIG
//  /   /        Filename		: vlog_xst_bl4_ddr2_dm_0.v
// /___/   /\    Date Last Modified	: $Date: 2007/02/07 15:52:34 $
// \   \  /  \   Date Created		: Mon May 2 2005
//  \___\/\___\
// Device	: Spartan-3/3A
// Design Name	: DDR2 SDRAM
// Purpose	: This module has instantiation DDR IOB output flip-flops, 
//	          and an output buffer for the data mask bits.
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps
`include "../source/sdramtst/vlog_xst_bl4_parameters_0.v"

module vlog_xst_bl4_ddr2_dm_0
  (
   input [(`data_mask_width-1):0]    mask_falling,
   input [(`data_mask_width-1):0]    mask_rising,
   input			                       clk90,
   output [(`data_mask_width-1):0]   ddr_dm
   );

   wire	[(`data_mask_width-1):0]     mask_o;  
   wire				     gnd;
   wire				     vcc;

   assign			     gnd = 1'b0;
   assign			     vcc = 1'b1;

// Data	Mask Output during a write command

   FDDRRSE  DDR2_DM0_OUT
     (
      .Q (mask_o[0]),
      .C0(~clk90),
      .C1(clk90),
      .CE(vcc),
      .D0(mask_rising[0]),
      .D1(mask_falling[0]),
      .R (gnd),
      .S (gnd)
      );
   FDDRRSE  DDR2_DM1_OUT
     (
      .Q (mask_o[1]),
      .C0(~clk90),
      .C1(clk90),
      .CE(vcc),
      .D0(mask_rising[1]),
      .D1(mask_falling[1]),
      .R (gnd),
      .S (gnd)
      );
   OBUF  DM0_OBUF
      (
       .I(mask_o[0]),
       .O(ddr_dm[0])
       );
   OBUF  DM1_OBUF
      (
       .I(mask_o[1]),
       .O(ddr_dm[1])
       );

endmodule
