///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// This design is confidential and proprietary of Xilinx, All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  /   Vendor			: Xilinx
// \   \   \/    Version		: $Name: mig_v1_7_b7 $
//  \   \        Application		: MIG
//  /   /        Filename		: vlog_xst_bl4_fifo_0_wr_en_0.v
// /___/   /\    Date Last Modified	: $Date: 2007/02/06 08:08:57 $
// \   \  /  \   Date Created		: Mon May 2 2005
//  \___\/\___\
// Device	: Spartan-3/3A
// Design Name	: DDR2 SDRAM
// Purpose	: This module generate the write enable signal to the fifos,
//		  which are driven by negedge data strobe.
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps
module vlog_xst_bl4_fifo_0_wr_en_0
  (
   input     clk,
   input     reset,
   input     din,
   output    rst_dqs_delay_n,
   output    dout
   );


   parameter TIE_HIGH = 1'b1;

   wire      din_delay;

   assign    rst_dqs_delay_n = ~din_delay;
   assign    dout = (din | (din_delay));


   FDCE delay_ff (.Q(din_delay), .C(clk), .CE(TIE_HIGH), .CLR (reset), .D(din));

endmodule
