///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// This	design is confidential and proprietary of Xilinx, All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /	/\/   /
// /___/  \  /   Vendor			: Xilinx
// \   \   \/    Version		: $Name: mig_v1_7_b7 $
//  \	\        Application		: MIG
//  /   /        Filename		: vlog_xst_bl4_fifo_1_wr_en_0.v
// /___/   /\    Date Last Modified	: $Date: 2007/02/19 12:03:15 $
// \   \  /  \   Date Created		: Mon May 2 2005
//  \___\/\___\
// Device	: Spartan-3/3A
// Design Name	: DDR2 SDRAM
// Purpose	: This module generate the write enable signal to the fifos, 
//		  which are driven by posedge data strobe.
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps
module vlog_xst_bl4_fifo_1_wr_en_0
  (
   input     clk,
   input     rst_dqs_delay_n,
   input     reset,
   input     din,
   output    dout
   );

   wire	     din_delay;
   wire	     dout0;
   wire	     rst_dqs_delay;

   parameter TIE_HIGH =	1'b1;

   assign    rst_dqs_delay = ~rst_dqs_delay_n;
   assign    dout0 = din & rst_dqs_delay_n;
   assign    dout = rst_dqs_delay | din_delay;

   FDCE	delay_ff_1
     (
      .Q(din_delay), 
      .C(clk), 
      .CE(TIE_HIGH), 
      .CLR(reset), 
      .D(dout0)
      );



endmodule
