///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// This design is confidential and proprietary of Xilinx, All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  /   Vendor			: Xilinx
// \   \   \/    Version		: $Name: mig_v1_7_b7 $
//  \   \        Application		: MIG
//  /   /        Filename		: vlog_xst_bl4_main_0.v
// /___/   /\    Date Last Modified	: $Date: 2007/02/06 08:08:58 $
// \   \  /  \   Date Created		: Mon May 2 2005
//  \___\/\___\
// Device	: Spartan-3/3A
// Design Name	: DDR2 SDRAM
// Purpose	: This modules has the instantiation for top and test_bench 
//		  modules.
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps
`include "../source/sdramtst/vlog_xst_bl4_parameters_0.v"

module    vlog_xst_bl4_main_0
  (

   input                                         clk_int,
   input                                         clk90_int,
   input [4:0]                                   delay_sel_val,
   input                                         wait_200us,
   input                                         sys_rst,
   input                                         sys_rst90,
   input                                         sys_rst180,
   input                                         refr_enable,
   input                                         rst_dqs_div_in,
   output                                        rst_dqs_div_out,
   output [(`clk_width-1):0]                     DDR2_CK,
   output [(`clk_width-1):0]                     DDR2_CK_N,
   output                                        DDR2_CAS_N,
   output                                        DDR2_CKE,
   output                                        DDR2_CS_N,
   output                                        DDR2_RAS_N,
   output                                        DDR2_WE_N,
   output                                        DDR2_ODT,
   output [`row_address-1:0]                     DDR2_A,
   output [`bank_address-1:0]                    DDR2_BA,
   inout [(`data_width-1):0]                     DDR2_DQ,
   inout [(`data_strobe_width-1):0]              DDR2_DQS,
   output       [((`data_mask_width)-1):0]  DDR2_DM,
    inout  [(`data_strobe_width-1):0] DDR2_DQS_N, 

   input  [31:0] mig_input_data, // 32-bit input
   input  [3:0]  mig_input_mask, // 4-bit input
   input  [25:0] mig_input_addr, // 26-bit input
   input  [3:0]  mig_input_cmds, // 4-bit input
   input         mig_input_burst_done, // 1-bit input
   output [31:0] mig_output_data, // 32-bit output
   output        mig_output_data_valid, // 1-bit output
   output        mig_output_cmds_ack, // 1-bit output
   output        mig_output_init_val, // 1-bit output
   output        mig_output_ar_request, // 1-bit output
   output        mig_output_ar_done // 1-bit output
   );


   wire [((`data_width*2)-1):0]                  user_output_data;
   wire [((`row_address +
           `col_ap_width  + `bank_address)-1):0] u1_address;
   wire                                          user_data_val1;
   wire [3:0]                                    user_cmd1;
   wire                                          auto_ref_req;
   wire                                          user_ack1;
   wire [((`data_width*2)-1):0]                  u1_data_i;
   wire [((`data_mask_width*2)-1):0]             u1_data_m;
   wire                                          burst_done_val1;
   wire                                          init_val1;
   wire                                          ar_done_val1;


   vlog_xst_bl4_top_0        top0
      (
       .auto_ref_req           (auto_ref_req),
       .wait_200us             (wait_200us),
       .refr_enable            (refr_enable),
       .rst_dqs_div_in           (rst_dqs_div_in),
       .rst_dqs_div_out        (rst_dqs_div_out),
       .user_input_data       (u1_data_i),
      .user_data_mask(u1_data_m),
       .user_output_data       (user_output_data),
       .user_data_valid       (user_data_val1),
       .user_input_address    (u1_address[((`row_address + `col_ap_width 
                                            + `bank_address)-1):0]),
       .user_command_register (user_cmd1),
       .user_cmd_ack             (user_ack1),
       .burst_done               (burst_done_val1),
       .init_val         (init_val1),
       .ar_done          (ar_done_val1),
       .DDR2_DQS         (DDR2_DQS),
      .DDR2_DQS_N (DDR2_DQS_N),
       .DDR2_DQ          (DDR2_DQ),
       .DDR2_CKE         (DDR2_CKE),
       .DDR2_CS_N        (DDR2_CS_N),
       .DDR2_RAS_N               (DDR2_RAS_N),
       .DDR2_CAS_N               (DDR2_CAS_N),
       .DDR2_WE_N        (DDR2_WE_N),
      .DDR2_DM          (DDR2_DM),

       .DDR2_ODT         (DDR2_ODT),
       .DDR2_BA          (DDR2_BA),
       .DDR2_A                   (DDR2_A),
       .DDR2_CK                (DDR2_CK),
       .DDR2_CK_N      (DDR2_CK_N),
       .clk_int                (clk_int),
       .clk90_int      (clk90_int),
       .delay_sel_val          (delay_sel_val),
       .sys_rst                (sys_rst),
       .sys_rst90      (sys_rst90),
       .sys_rst180             (sys_rst180)
       );

//   vlog_xst_bl4_ddr2_test_bench_0    ddr2_test_bench0
//      (
//       .auto_ref_req      (auto_ref_req),
//       .fpga_clk          (clk_int),
//       .fpga_rst90        (sys_rst90),
//       .fpga_rst180       (sys_rst180),
//       .clk90             (clk90_int),
//       .burst_done        (burst_done_val1),
//       .INIT_DONE         (init_val1),
//       .ar_done           (ar_done_val1),
//       .u_ack             (user_ack1),
//       .u_data_val        (user_data_val1),
//       .u_data_o          (user_output_data),
//       .u_addr            (u1_address),
//       .u_cmd             (user_cmd1),
//       .u_data_i          (u1_data_i),
//       .u_data_m          (u1_data_m),
//       .led_error_output  (led_error_output1),
//       .data_valid_out    (data_valid_out)
//       );

  assign mig_output_data = user_output_data;
  assign mig_output_data_valid = user_data_val1;
  assign mig_output_cmds_ack = user_ack1;
  assign mig_output_init_val = init_val1;
  assign mig_output_ar_request = auto_ref_req;
  assign mig_output_ar_done = ar_done_val1;

  assign burst_done_val1 = mig_input_burst_done;
  assign u1_data_i = mig_input_data;
  assign u1_data_m = mig_input_mask;
  assign u1_address = mig_input_addr;
  assign user_cmd1 = mig_input_cmds;

endmodule