///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// This design is confidential and proprietary of Xilinx, All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  /   Vendor			: Xilinx
// \   \   \/    Version		: $Name: mig_v1_7_b7 $
//  \   \        Application		: MIG
//  /   /        Filename		: vlog_xst_bl4_s3_ddr_iob.v
// /___/   /\    Date Last Modified	: $Date: 2007/02/19 14:09:24 $
// \   \  /  \   Date Created		: Mon May 2 2005
//  \___\/\___\
// Device	: Spartan-3/3A
// Design Name	: DDR2 SDRAM
// Purpose	:
///////////////////////////////////////////////////////////////////////////////


`timescale 1ns/100ps
module vlog_xst_bl4_s3_ddr_iob
  (
   inout     ddr_dq_inout,
   input     write_data_falling,
   input     write_data_rising,
   input     clk90,
   input     write_en_val,
   output    read_data_in
   );

   parameter GND = 1'b0;
   parameter CLOCK_EN = 1'b1;

   wire      ddr_en;    
   wire      ddr_dq_q;  
   wire      enable_b;
   wire      write_data_rising1;
   wire      write_data_falling1;

   assign    enable_b = ~ write_en_val;


   assign #1 write_data_rising1  = write_data_rising;

   assign #1 write_data_falling1 = write_data_falling;

//Transmission data path

   FDDRRSE DDR_OUT
     (
      .Q  (ddr_dq_q),
      .C0 (~clk90),
      .C1 (clk90),
      .CE (CLOCK_EN),
      .D0 (write_data_rising1),
      .D1 (write_data_falling1),
      .R  (GND),
      .S  (GND)
      );

   FD DQ_T
     (
      .D   (enable_b),
      .C   (~clk90),
      .Q   (ddr_en)
      );

   OBUFT DQ_OBUFT
     (
      .I (ddr_dq_q),
      .T (ddr_en),
      .O (ddr_dq_inout)
      );

//Receive data path

   IBUF DQ_IBUF
     (
      .I (ddr_dq_inout),
      .O (read_data_in)
      );
endmodule
